procedure cfgcomp(file1,file2)
#compare configuration files for deviations

# Revision History
# v.0.0.2 2002-Feb-12 by J. Tufts
#  - added output to temporary file to be used by curfit
# v.0.0.1 2002-Feb-11 by J. Tufts
#  - program creation

char   file1 {"",prompt="File 1 (reference)"}
char   file2 {"",prompt="File 2 (comparision)"}

begin

int    slit,count
char   temp,sl,slpos
char   n_file1,n_file2
real   inpos[13]
real   comppos[13]
int    usein[13],usecomp[13]
real   diff,sum,sumsq,average

n_file1 = file1
n_file2 = file2

list = n_file1
while (fscan(list,sl,slpos) != EOF) {
  if (stridx("#",sl) != 1) {
    slit = int(sl)
    if (slpos != "-") {
      usein[slit] = 1
      inpos[slit] = real(slpos)
    }
    else {
      usein[slit] = 0
    }
  }
}
list = n_file2
while (fscan(list,sl,slpos) != EOF) {
  if (stridx("#",sl) != 1) {
    slit = int(sl)
    if (slpos != "-") {
      usecomp[slit] = 1
      comppos[slit] = real(slpos)
    }
    else {
      usecomp[slit] = 0
    }
  }
}


# Do math
sum = 0
sumsq = 0
# Formatted screen output
print  ("")
printf ("Slit | O.setup pos | New Setup pos | Deviation\n")
printf ("-----+-------------+---------------+----------\n")
for (count = 1;count <= 13;count += 1) {
  diff = inpos[count]-comppos[count]
  printf (" %3d |   ",count)
  if (usein[count]==1) {
    printf ("%7.3f   |",inpos[count])
  }
  else {
    printf ("    -     |")
  }
  if (usecomp[count]==1) {
    printf ("    %7.3f    |",comppos[count])
  }
  else {
    printf ("        -      |")
  }
  if (usecomp[count]==1 && usein[count]==1) {
    printf ("  %7.3f\n",diff)
    sum += diff
    sumsq += (diff * diff)
  }
  else {
    printf ("      -\n")
  }
}  
printf ("-----+-------------+---------------+----------\n")
#printf ("Average   = %-7.3d\n",sum)
#printf ("Std. Dev. = %-7.3d\n",

# Data file output
temp=mktemp("plt")
sl=mktemp("fit")
for (count = 1;count <= 13;count += 1) {
  if (usecomp[count]==1 && usein[count]==1) {
    printf ("%3d %7.3f\n",count,inpos[count]-comppos[count],>> temp)
  }
}
curfit (temp,order=2,interac=yes,power=yes)

delete (temp)
delete (s1)
end
